/***************************************************************************
 *   Copyright (C) 2009 by Manuel Schrape                                  *
 *   manuel.schrape@gmx.de                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "HandlerKML.h"

HandlerKML::HandlerKML()
{
}

QString HandlerKML::get_Header(QString Name)
{
    QString block;
    block = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n"
            "<kml xmlns=\"http://earth.google.com/kml/2.2\">\n"
            "  <Document>\n"
            "    <name>" + Name + "</name>\n"
            "    <Style id=\"MK_gps-style\">\n"
            "      <LineStyle>\n"
            "        <color>ff0000ff</color>\n"
            "        <width>2</width>\n"
            "      </LineStyle>\n"
            "    </Style>\n"
            "    <Placemark>\n"
            "      <LookAt>\n"
            "        <range>400</range>\n"
            "        <tilt>45</tilt>\n"
            "      </LookAt>\n"
            "      <name>Flight</name>\n"
            "      <styleUrl>#MK_gps-style</styleUrl>\n"
            "      <LineString>\n"
            "        <extrude>1</extrude>\n"
            "        <tessellate>1</tessellate>\n"
            "        <altitudeMode>absolute</altitudeMode>\n"
            "        <coordinates>\n";

    return block;
}

QString HandlerKML::get_Footer()
{
    QString block;
    block = "        </coordinates>\n"
            "      </LineString>\n"
            "    </Placemark>\n"
            "  </Document>\n"
            "</kml>\n";

    return block;
}
