/***************************************************************************
 *   Copyright (C) 2009 by Manuel Schrape                                  *
 *   manuel.schrape@gmx.de                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef INPUT_H
#define INPUT_H

#include <QObject>

enum eMode {NONE, TCP, TTY};

struct set_Input
{
    QString Main;
    QString Sub;
};

struct s_Resend
{
    bool ID;
    QString Data;
};

static const int CLOSED       = 0;
static const int REFUSED      = 1;
static const int REMOTECLOSED = 2;

static const int MAX_Confirm = 11;

class Input : public QObject
{
    Q_OBJECT

    public:
        virtual void Init();
        virtual bool Open(set_Input s_Input);
        virtual bool IsOpen();
        virtual bool Close();
        virtual void send_Data(QString t_Data, int ID = 0);
        virtual void send_RawData(char *t_Data);
        virtual void stop_Resend(int ID);
        virtual eMode Mode();

    signals:
        virtual void sig_NewData(QString Data);

//    private:

};

#endif // INPUT_H
