/***************************************************************************
 *   Copyright (C) 2009 by Manuel Schrape                                  *
 *   manuel.schrape@gmx.de                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef INPUT_TTY_H
#define INPUT_TTY_H

#include <QObject>
#include <QTimer>

#include "Input.h"
#include "../Class_SerialPort/ManageSerialPort.h"

class Input_TTY : public Input
{
    Q_OBJECT

    public:
        void Init();
        bool Open(set_Input s_Input);
        bool IsOpen();
        bool Close();
        void send_Data(QString t_Data, int ID = 0);
        void send_RawData(char *t_Data);
        void stop_Resend(int ID);
        eMode Mode();

    private:
        ManageSerialPort *o_TTY;
        QString  s_RX;
        QTimer   *Timer;
        s_Resend Confirm[MAX_Confirm];

    private slots:
        void slot_Receive(const QByteArray &dataReceived);
        void slot_Timer();

    signals:
        void sig_NewData(QString Data);

};

#endif // INPUT_TTY_H
