/***************************************************************************
 *   Copyright (C) 2008 by Manuel Schrape                                  *
 *   manuel.schrape@gmx.de                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CSETTINGS_H
#define CSETTINGS_H

#include <QSize>
#include <QPoint>
#include <QString>

#include "../Defines.h"

struct set_SERVER
{
    int TCP_PORT;
    int UDP_PORT;
    QString Password;
};

struct set_LIVEDATA
{
    QString Server;
    QString Port;
    QString User;
    QString Password;
};

struct set_CLIENT
{
    QString TTY_DEVICES[10];
    int     TTY_MAX;
    int     TTY_ID;

    QString TCP_SERVER[10];
    QString TCP_Password;
    int     TCP_MAX;
    int     TCP_ID;
};

struct set_GUI
{
    bool   isMax;
    QSize  Size;
    QPoint Point;
};

struct set_DATA
{
    bool Send;
    bool Data;
    bool Info;
    bool TCP;
};

class cSettings
{
    public:
        cSettings();
        void read_Settings();
        void write_Settings();

        int Settings_ID;

        set_DATA   DATA;
        set_GUI    GUI;
        set_GUI    TERMINAL;
        set_SERVER SERVER;
        set_CLIENT CLIENT;
        set_LIVEDATA LIVEDATA;
};

#endif // CSETTINGS_H
