/***************************************************************************
 *   Copyright (C) 2008 by Manuel Schrape                                  *
 *   manuel.schrape@gmx.de                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef CSETTINGS_H
#define CSETTINGS_H

#include <QBitArray>
#include <QSize>
#include <QPoint>

#include "../../Global/Kopter.h"
#include "../Defines.h"

struct set_DebugData
{
    QString   Version;
    QString   Label[MAX_DebugData];
    QBitArray Show_Plotter;
//    QBitArray LogView;
};

struct set_GUI
{
    bool   isMax;
    QSize  Size;
    QPoint Point;
};

struct set_DATA
{
    int Plotter_Count;
//    int Debug_Intervall;
};
/*
struct set_SERVER
{
    int IP_MAX;
    int IP_ID;
    QString IP[10];
    QString Password;
};
*/
class cSettings
{
    public:
        cSettings();

        int Settings_ID;

        set_GUI       GUI;
        set_DebugData DebugData;
        set_DATA      DATA;
//        set_SERVER    SERVER;

        void read_DebugLabels(int ID);
        void write_DebugLabels(int ID);

        void read_Settings();
        void write_Settings();


};

#endif // CSETTINGS_H
