/***************************************************************************
 *   Copyright (C) 2008 by Manuel Schrape                                  *
 *   manuel.schrape@gmx.de                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License.        *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "dlg_MotorTest.h"

dlg_MotorTest::dlg_MotorTest(QWidget *parent) : QDialog(parent)
{
    setupUi(this);

    Timer = new QTimer();
    Timer->setInterval(250);

    connect(sl_Speed, SIGNAL(valueChanged(int)), this, SLOT(slot_MotorTest(int)));
    connect(Timer, SIGNAL(timeout()), this, SLOT(slot_Timer()));
}

void dlg_MotorTest::slot_MotorTest(int Wert)
{
    if ((Wert > 0) && !(Timer->isActive()))
    {
        Timer->start();
    }    

    for (int z = 0; z < 16; z++)
    {
        Motor[z] = 0;
    }

    if (cb_1->isChecked())
        Motor[0] = Wert;
    if (cb_2->isChecked())
        Motor[1] = Wert;
    if (cb_3->isChecked())
        Motor[2] = Wert;
    if (cb_4->isChecked())
        Motor[3] = Wert;
    if (cb_5->isChecked())
        Motor[4] = Wert;
    if (cb_6->isChecked())
        Motor[5] = Wert;
    if (cb_7->isChecked())
        Motor[6] = Wert;
    if (cb_8->isChecked())
        Motor[7] = Wert;
    if (cb_9->isChecked())
        Motor[8] = Wert;
    if (cb_10->isChecked())
        Motor[9] = Wert;
    if (cb_11->isChecked())
        Motor[10] = Wert;
    if (cb_12->isChecked())
        Motor[11] = Wert;
}

void dlg_MotorTest::slot_Timer()
{
    memcpy((unsigned char *)&c_Data, (unsigned char *)&Motor, sizeof(Motor));

    emit sig_SendData(HandlerMK::make_Frame('t', ADDRESS_FC, c_Data, sizeof(Motor)).toLatin1().data(), 0);
}

void dlg_MotorTest::Stop()
{
    Timer->stop();
}

dlg_MotorTest::~dlg_MotorTest()
{
}


